using System;
using System.Collections.Generic;
using System.Runtime.Serialization;
using System.ServiceModel;

namespace UnifiedPOS.VoiceRecognition.V1_4
{
    [ServiceContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/")]
    public interface VoiceRecognition
    {
        #region Version 1.1

        //
        // Common Properties
        //

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetAutoDisable", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetAutoDisableResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        bool GetAutoDisable(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/SetAutoDisable", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/SetAutoDisableResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        void SetAutoDisable(string ConsumerID, bool AutoDisable);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetCapCompareFirmwareVersion", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetCapCompareFirmwareVersionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        bool GetCapCompareFirmwareVersion(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetCapPowerReporting", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetCapPowerReportingResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        PowerReporting GetCapPowerReporting(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetCapStatisticsReporting", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetCapStatisticsReportingResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        bool GetCapStatisticsReporting(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetCapUpdateFirmware", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetCapUpdateFirmwareResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        bool GetCapUpdateFirmware(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetCapUpdateStatistics", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetCapUpdateStatisticsResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        bool GetCapUpdateStatistics(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetCheckHealthText", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetCheckHealthTextResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        string GetCheckHealthText(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetClaimed", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetClaimedResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        bool GetClaimed(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetDataCount", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetDataCountResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        int GetDataCount(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetDataEventEnabled", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetDataEventEnabledResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        bool GetDataEventEnabled(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/SetDataEventEnabled", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/SetDataEventEnabledResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        void SetDataEventEnabled(string ConsumerID, bool DataEventEnabled);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetDeviceEnabled", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetDeviceEnabledResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        bool GetDeviceEnabled(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/SetDeviceEnabled", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/SetDeviceEnabledResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        void SetDeviceEnabled(string ConsumerID, bool DeviceEnabled);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetFreezeEvents", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetFreezeEventsResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        bool GetFreezeEvents(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/SetFreezeEvents", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/SetFreezeEventsResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        void SetFreezeEvents(string ConsumerID, bool FreezeEvents);

        //[OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetOutputID", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetOutputIDResponse")]
        //[FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        //int GetOutputID(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetPowerNotify", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetPowerNotifyResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        PowerNotification GetPowerNotify(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/SetPowerNotify", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/SetPowerNotifyResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        void SetPowerNotify(string ConsumerID, PowerNotification PowerNotify);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetPowerState", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetPowerStateResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        PowerState GetPowerState(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetState", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetStateResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        ControlState GetState(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetDeviceControlDescription", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetDeviceControlDescriptionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        string GetDeviceControlDescription(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetDeviceControlVersion", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetDeviceControlVersionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        UposVersion GetDeviceControlVersion(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetDeviceServiceDescription", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetDeviceServiceDescriptionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        string GetDeviceServiceDescription(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetDeviceServiceVersion", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetDeviceServiceVersionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        UposVersion GetDeviceServiceVersion(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetPhysicalDeviceDescription", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetPhysicalDeviceDescriptionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        string GetPhysicalDeviceDescription(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetPhysicalDeviceName", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetPhysicalDeviceNameResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        string GetPhysicalDeviceName(string ConsumerID);

        //
        // Specific Properties
        //

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetCapLanguage", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetCapLanguageResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        bool GetCapLanguage(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetHearingResult", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetHearingResultResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        HearingResult GetHearingResult(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetHearingStatus", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetHearingStatusResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        HearingStatus GetHearingStatus(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetHearingDataPattern", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetHearingDataPatternResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        string GetHearingDataPattern(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetHearingDataWord", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetHearingDataWordResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        VoiceWordList GetHearingDataWord(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetLanguageList", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetLanguageListResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        LanguageList GetLanguageList(string ConsumerID);

        //
        // Common Methods
        //

        //[OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/Open", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/OpenResponse")]
        //[FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        //void Open(string ConsumerID, string EndpointAddress);

        //[OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/Close", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/CloseResponse")]
        //[FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        //void Close(string ConsumerID, string EndpointAddress);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/Claim", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/ClaimResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        void Claim(string ConsumerID, int Timeout);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/Release", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/ReleaseResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        void Release(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/CheckHealth", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/CheckHealthResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        void CheckHealth(string ConsumerID, HealthCheckLevel Level);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/ClearInput", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/ClearInputResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        void ClearInput(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/ClearInputProperties", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/ClearInputPropertiesResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        void ClearInputProperties(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/ClearOutput", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/ClearOutputResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        void ClearOutput(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/DirectIO", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/DirectIOResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        DirectIOData DirectIO(string ConsumerID, int Command, int Data, object Obj);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/CompareFirmwareVersion", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/CompareFirmwareVersionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        CompareFirmwareResult CompareFirmwareVersion(string ConsumerID, string FirmwareFileName);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/ResetStatistics", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/ResetStatisticsResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        void ResetStatistics(string ConsumerID, StatisticList StatisticsBuffer);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/RetrieveStatistics", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/RetrieveStatisticsResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        string RetrieveStatistics(string ConsumerID, StatisticList StatisticsBuffer);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UpdateFirmware", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UpdateFirmwareResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        void UpdateFirmware(string ConsumerID, string FirmwareFileName);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UpdateStatistics", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UpdateStatisticsResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        void UpdateStatistics(string ConsumerID, StatisticList StatisticsBuffer);

        //
        // Specific Methods
        //

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/StartHearingFree", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/StartHearingFreeResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        void StartHearingFree(string ConsumerID, string Language);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/StartHearingSentence", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/StartHearingSentenceResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        void StartHearingSentence(string ConsumerID, string Language, VoiceWordList WordList, VoicePatternList PatternList);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/StartHearingWord", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/StartHearingWordResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        void StartHearingWord(string ConsumerID, string Language);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/StartHearingYesNo", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/StartHearingYesNoResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        void StartHearingYesNo(string ConsumerID, string Language);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/StopHearing", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/StopHearingResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        void StopHearing(string ConsumerID);

        //
        // Session Management
        //

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetWSPOSVersion", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetWSPOSVersionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        UposVersion GetWSPOSVersion();

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GenerateConsumerID", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GenerateConsumerIDResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        string GenerateConsumerID();

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/OpenSession", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/OpenSessionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        void OpenSession(string ConsumerID, string EndpointAddress);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/CloseSession", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/CloseSessionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        void CloseSession(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetProviderSessionTimeout", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetProviderSessionTimeoutResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        int GetProviderSessionTimeout(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/KeepAlive", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/KeepAliveResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        void KeepAlive(string ConsumerID);

        //
        // Device Control
        //

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/OpenDevice", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/OpenDeviceResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        void OpenDevice(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/CloseDevice", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/CloseDeviceResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        void CloseDevice(string ConsumerID);

        //
        // Event Polling
        //

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/PollForUPOSEvent", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/PollForUPOSEventResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        VoiceRecognitionEvent PollForUPOSEvent(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/SetEventResponse", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/SetEventResponseResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        void SetEventResponse(string ConsumerID, VoiceRecognitionEventResponse EventResponse);

        #endregion Version 1.1

        #region Version 1.3

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetEncryptedClaimedConsumerID", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/GetEncryptedClaimedConsumerIDResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        string GetEncryptedClaimedConsumerID();

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/SetEventRequestProperties", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/SetEventRequestPropertiesResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/UposException", Name = "UposException")]
        void SetEventRequestProperties(string ConsumerID, PropertyNameList list);

        #endregion Version 1.3
    }

    #region Version 1.1

    //
    // Common Data Types
    //

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/")]
    public class DirectIOData
    {
        [DataMember]
        public int Data { get; set; }

        [DataMember]
        public object Obj { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/")]
    public class UposException
    {
        [DataMember]
        public ErrorCode ErrorCode { get; set; }

        [DataMember]
        public int ErrorCodeExtended { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/")]
    public class UposVersion
    {
        [DataMember]
        public int Major { get; set; }

        [DataMember]
        public int Minor { get; set; }

        [DataMember]
        public int Build { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/")]
    public class Statistic
    {
        [DataMember]
        public string Name { get; set; }

        [DataMember]
        public string Value { get; set; }
    }

    [CollectionDataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/", ItemName = "Statistic")]
    public class StatisticList : List<Statistic>
    {
    }

    //
    // Common Enumerations
    //

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/")]
    public enum CompareFirmwareResult
    {
        [EnumMember]
        CFV_FIRMWARE_OLDER,

        [EnumMember]
        CFV_FIRMWARE_SAME,

        [EnumMember]
        CFV_FIRMWARE_NEWER,

        [EnumMember]
        CFV_FIRMWARE_DIFFERENT,

        [EnumMember]
        CFV_FIRMWARE_UNKNOWN,
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/")]
    public enum ControlState
    {
        [EnumMember]
        S_CLOSED,

        [EnumMember]
        S_IDLE,

        [EnumMember]
        S_BUSY,

        [EnumMember]
        S_ERROR,
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/")]
    public enum ErrorCode
    {
        [EnumMember]
        E_CLOSED,

        [EnumMember]
        E_CLAIMED,

        [EnumMember]
        E_NOTCLAIMED,

        [EnumMember]
        E_NOSERVICE,

        [EnumMember]
        E_DISABLED,

        [EnumMember]
        E_ILLEGAL,

        [EnumMember]
        E_NOHARDWARE,

        [EnumMember]
        E_OFFLINE,

        [EnumMember]
        E_NOEXIST,

        [EnumMember]
        E_EXISTS,

        [EnumMember]
        E_FAILURE,

        [EnumMember]
        E_TIMEOUT,

        [EnumMember]
        E_BUSY,

        [EnumMember]
        E_EXTENDED,

        [EnumMember]
        E_DEPRECATED,
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/")]
    public enum HealthCheckLevel
    {
        [EnumMember]
        CH_INTERNAL,

        [EnumMember]
        CH_EXTERNAL,

        [EnumMember]
        CH_INTERACTIVE,
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/")]
    public enum PowerNotification
    {
        [EnumMember]
        PN_DISABLED,

        [EnumMember]
        PN_ENABLED,
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/")]
    public enum PowerReporting
    {
        [EnumMember]
        PR_NONE,

        [EnumMember]
        PR_STANDARD,

        [EnumMember]
        PR_ADVANCED,
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/")]
    public enum PowerState
    {
        [EnumMember]
        PS_UNKNOWN,

        [EnumMember]
        PS_ONLINE,

        [EnumMember]
        PS_OFF,

        [EnumMember]
        PS_OFFLINE,

        [EnumMember]
        PS_OFF_OFFLINE,
    }

    /*
    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/")]
    public enum StatisticCategories
    {
        [EnumMember]
        All,
        [EnumMember]
        Manufacturer,
        [EnumMember]
        Upos,
    }
    */

    public class StatisticCategories
    {
        public const string All = "";
        public const string Manufacturer = "M_";
        public const string Upos = "U_";
    }

    //
    // Specific Data Types
    //

    [CollectionDataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/", ItemName = "Word")]
    public class WordList : List<string>
    {
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/")]
    public class VoiceWord
    {
        [DataMember]
        public string GroupId { get; set; }

        [DataMember]
        public WordList WordList { get; set; }
    }

    [CollectionDataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/", ItemName = "VoiceWord")]
    public class VoiceWordList : List<VoiceWord>
    {
    }

    [CollectionDataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/", ItemName = "Language")]
    public class LanguageList : List<string>
    {
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/")]
    public class VoicePattern
    {
        [DataMember]
        public string PatternId { get; set; }

        [DataMember]
        public string Pattern { get; set; }
    }

    [CollectionDataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/", ItemName = "VoicePattern")]
    public class VoicePatternList : List<VoicePattern>
    {
    }

    //
    // Specific Enumerations
    //

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/")]
    public enum HearingResult
    {
        [EnumMember]
        VRCG_HRESULT_YESNO_YES,

        [EnumMember]
        VRCG_HRESULT_YESNO_NO,

        [EnumMember]
        VRCG_HRESULT_YESNO_CANCEL,

        [EnumMember]
        VRCG_HRESULT_WORD,

        [EnumMember]
        VRCG_HRESULT_SENTENCE,

        [EnumMember]
        VRCG_HRESULT_FREE,
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/")]
    public enum HearingStatus
    {
        [EnumMember]
        VRCG_HSTATUS_NONE,

        [EnumMember]
        VRCG_HSTATUS_YESNO,

        [EnumMember]
        VRCG_HSTATUS_WORD,

        [EnumMember]
        VRCG_HSTATUS_SENTENCE,

        [EnumMember]
        VRCG_HSTATUS_FREE,
    }

    //
    // Constants
    //

    public class ExtendedError
    {
        public const int EFIRMWARE_BAD_FILE = 281;
        public const int ESTATS_ERROR = 280;
        public const int ESTATS_DEPENDENCY = 282;
    }

    public class StatisticProperties
    {
        public const string CommunicationErrorCount = "CommunicationErrorCount";
        public const string DeviceCategory = "DeviceCategory";
        public const string FirmwareRevision = "FirmwareRevision";
        public const string HoursPoweredCount = "HoursPoweredCount";
        public const string InstallationDate = "InstallationDate";
        public const string Interface = "Interface";
        public const string ManufactureDate = "ManufactureDate";
        public const string ManufacturerName = "ManufacturerName";
        public const string MechanicalRevision = "MechanicalRevision";
        public const string ModelName = "ModelName";
        public const string SerialNumber = "SerialNumber";
        public const string UnifiedPOSVersion = "UnifiedPOSVersion";
    }

    public class Wait
    {
        public const int FOREVER = -1;
    }

    #endregion Version 1.1

    #region Version 1.2

    //
    // Event Polling
    //

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/")]
    public class VoiceRecognitionEvent
    {
        [DataMember]
        public DataEvent DataEvent { get; set; }

        [DataMember]
        public DirectIOEvent DirectIOEvent { get; set; }

        [DataMember]
        public ErrorEvent ErrorEvent { get; set; }

        //[DataMember]
        //public OutputCompleteEvent OutputCompleteEvent { get; set; }
        [DataMember]
        public StatusUpdateEvent StatusUpdateEvent { get; set; }

        [DataMember]
        public DataContainedEvent DataContainedEvent { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/")]
    public class VoiceRecognitionEventResponse
    {
        [DataMember]
        public DataEventResponse DataEventResponse { get; set; }

        [DataMember]
        public DataContainedEventResponse DataContainedEventResponse { get; set; }

        [DataMember]
        public DirectIOEventResponse DirectIOEventResponse { get; set; }

        [DataMember]
        public ErrorEventResponse ErrorEventResponse { get; set; }

        //[DataMember]
        //public OutputCompleteEventResponse OutputCompleteEventResponse { get; set; }
        [DataMember]
        public StatusUpdateEventResponse StatusUpdateEventResponse { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/")]
    public class DataEvent
    {
        [DataMember]
        public string Source { get; set; }

        [DataMember]
        public int EventID { get; set; }

        [DataMember]
        public DateTime TimeStamp { get; set; }

        [DataMember]
        public int Status { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/")]
    public class DataEventResponse
    {
        [DataMember]
        public int EventID { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/")]
    public class DirectIOEvent
    {
        [DataMember]
        public string Source { get; set; }

        [DataMember]
        public int EventID { get; set; }

        [DataMember]
        public DateTime TimeStamp { get; set; }

        [DataMember]
        public int EventNumber { get; set; }

        [DataMember]
        public int Data { get; set; }

        [DataMember]
        public object Obj { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/")]
    public class DirectIOEventResponse
    {
        [DataMember]
        public int EventID { get; set; }

        [DataMember]
        public DirectIOData DirectIOData { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/")]
    public class ErrorEvent
    {
        [DataMember]
        public string Source { get; set; }

        [DataMember]
        public int EventID { get; set; }

        [DataMember]
        public DateTime TimeStamp { get; set; }

        [DataMember]
        public ErrorCode ErrorCode { get; set; }

        [DataMember]
        public int ErrorCodeExtended { get; set; }

        [DataMember]
        public ErrorLocus ErrorLocus { get; set; }

        [DataMember]
        public ErrorResponse ErrorResponse { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/")]
    public class ErrorEventResponse
    {
        [DataMember]
        public int EventID { get; set; }

        [DataMember]
        public ErrorResponse ErrorResponse { get; set; }
    }

    /*
    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/")]
    public class OutputCompleteEvent
    {
        [DataMember]
        public string Source { get; set; }
        [DataMember]
        public int EventID { get; set; }
        [DataMember]
        public DateTime TimeStamp { get; set; }
        [DataMember]
        public int OutputID { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/")]
    public class OutputCompleteEventResponse
    {
        [DataMember]
        public int EventID { get; set; }
    }
    */

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/")]
    public class StatusUpdateEvent
    {
        [DataMember]
        public string Source { get; set; }

        [DataMember]
        public int EventID { get; set; }

        [DataMember]
        public DateTime TimeStamp { get; set; }

        [DataMember]
        public int Status { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/")]
    public class StatusUpdateEventResponse
    {
        [DataMember]
        public int EventID { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/")]
    public enum ErrorLocus
    {
        [EnumMember]
        EL_INPUT,

        [EnumMember]
        EL_INPUT_DATA,

        [EnumMember]
        EL_OUTPUT,
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/")]
    public enum ErrorResponse
    {
        [EnumMember]
        ER_CLEAR,

        [EnumMember]
        ER_CONTINUEINPUT,

        [EnumMember]
        ER_RETRY,
    }

    #endregion Version 1.2

    #region Version 1.3

    [CollectionDataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/", ItemName = "PropertyName")]
    public class PropertyNameList : List<string>
    {
    }

    [CollectionDataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/", ItemName = "Parameter")]
    public class ParameterList : Dictionary<string, object>
    {
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/")]
    public class DataContainedEvent
    {
        [DataMember]
        public string Source { get; set; }

        [DataMember]
        public int EventID { get; set; }

        [DataMember]
        public DateTime TimeStamp { get; set; }

        [DataMember]
        public int Status { get; set; }

        [DataMember]
        public ParameterList Parameters { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/")]
    public class DataContainedEventData
    {
        [DataMember]
        public int EventID { get; set; }

        [DataMember]
        public bool SetDataEventEnabled { get; set; }

        [DataMember]
        public bool CallClearInputProperties { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/VoiceRecognition/")]
    public class DataContainedEventResponse
    {
        [DataMember]
        public int EventID { get; set; }

        [DataMember]
        public bool SetDataEventEnabled { get; set; }

        [DataMember]
        public bool CallClearInputProperties { get; set; }
    }

    #endregion Version 1.3
}